import java.util.*;

public class Arraz {
    private int[] spiffyHandyIntArray = new int[]{4, 5, 102, 6, -7, 12, -32, 92, 8};

    public int sumOfIntArray(int[] numsArray) {
        int sum = 0;
        for (int i = 0; i < numsArray.length; i++) {
            sum += numsArray[i];
        }
        return sum;
    }

    public Double sumOfDoubleArray(Double[] doubleArray) {
        Double sum = 0.0;
        for (int i = 0; i < doubleArray.length; i++) {
            sum += doubleArray[i];
        }
        return sum;
    }

    public int averageOfIntArray(int[] intArray) {
        int average = (sumOfIntArray(intArray)) / intArray.length;
        return average;
    }


    public Double averageOfDoubleArray(Double[] doubleArray) {
        Double average = (sumOfDoubleArray(doubleArray)) / doubleArray.length;
        return average;
    }

    public boolean containsValue(int[] intArray, int numberToCheck) {
        for (int i = 0; i < intArray.length; i++) {
            if (numberToCheck == intArray[i]) {
                return true;
            }
        }
        return false;
    }


    public int[] reverseArray(int[] ints) {
        int newIndex = 0;
        int[] reversedArray = new int[ints.length];
        for (int i = ints.length - 1; i >= 0; i--) {
            reversedArray[newIndex] = ints[i];
            newIndex++;
        }
        return reversedArray;
    }


    public OddEven getOddEvensOfArray(int[] ints) {
        int odds = 0;
        int evens = 0;
        for (int i = 0; i < ints.length; i++) {
            if (ints[i] % 2 == 0) {
                evens++;
            } else {
                odds++;
            }
        }
        OddEven oe = new OddEven(odds, evens);
        return oe;
    }


    public int findIndexOf(int[] ints, int valueToFindIndexOf) {
        int index = 0;
        for (int i = 0; i < ints.length; i++) {
            if (ints[i] == valueToFindIndexOf) {
                index = i;
            }
        }
        return index;
    }

    public Integer[] copyArrayByIterator(Integer[] ints) {
        Integer[] newbie = new Integer[ints.length];
        int index = 0;
        Iterator<Integer> integerIterator = Arrays.asList(ints).iterator();
        while (integerIterator.hasNext()) {
            newbie[index] = integerIterator.next();
            index++;
        }
        return newbie;
    }

    public int[] copyArrayByLoop(int[] inty) {
        int[] newArray = new int[inty.length];
        for (int i = 0; i < inty.length; i++) {
            newArray[i] = inty[i];
        }
        return newArray;
    }

    public int[] removeElementFromArray(int[] intArray, int valueToRemove) {
        int begin = 0;
        int[] newArray = new int[intArray.length - 1];
        for (int i = 0; i < intArray.length; i++) {
            if (intArray[i] != valueToRemove) {
                newArray[begin] = intArray[i];
                begin++;
            }
        }
        return newArray;
    }

    public int[] insertIntoArrayAt(int[] ints, int position, int value) {
        int newIndex = 0;
        int[] newArray = new int[ints.length + 1];
        for (int i = 0; i < newArray.length - 1; i++) {
            if (i == position) {
                newArray[newIndex] = value;
                newIndex++;
            }
            newArray[newIndex] = ints[i];
            newIndex++;
        }
        return newArray;
    }

    public MinMax findMaxMinOfArray(int[] intArray) {
        int max = intArray[0];
        int min = intArray[0];
        for (int i = 0; i < intArray.length; i++) {

            if (intArray[i] > max) {
                max = intArray[i];
            } else if (intArray[i] < min) {
                min = intArray[i];
            }
        }
        return new MinMax(max, min);
    }

    public Integer countDupes(Integer[] ints) {
        Arrays.sort(ints);
        int counter = 0;
        for (int i = 0; i < ints.length; i++) {
            for (int j = i + 1; j < ints.length; j++) {
                if (ints[j].equals(ints[i])) {
                    counter++;
                }
            }
        }
        return counter;
    }


    public Integer[] removeDupesFromArray(Integer[] ints) {
        Integer[] newArray = new Integer[ints.length - countDupes(ints)];
        int newIndex = 0;
        for (int i = 0; i < ints.length; i++) {
            if (ints[i] != ints[i + 1]) {
                newArray[newIndex] = ints[i];
                newIndex++;
            }
        }

        return newArray;
    }

    public Double find2ndLargestValueFromArray(Double[] doubles) {
        Double highest = doubles[0];
        Double secondHightest = 0.0;
        for (int i = 0; i < doubles.length; i++) {
            if (doubles[i] > highest) {
                secondHightest = highest;
                highest = doubles[i];
            } else
                secondHightest = doubles[i];
        }
        return secondHightest;
    }


    public void makeMeAnArrayListFromArray(int[] ints) {
        ArrayList arrayList = new ArrayList(Arrays.asList(ints));
    }


    public boolean check2ArraysForEqual(int[] intArray1, int[] intArray2) {
        if (Arrays.equals(intArray1, intArray2)) {
            return true;
        } else
            return false;
    }


    public int averageArrayWithoutMaxMin(int[] ints) {
        int max = findMaxMinOfArray(ints).getMax();
        int min = findMaxMinOfArray(ints).getMin();
        int[] newerArray = new int[0];
        while (max > min) {
            int[] newArray = removeElementFromArray(ints, max);
            newerArray = removeElementFromArray(newArray, min);
            break;
        }
        return averageOfIntArray(newerArray);
    }


    public boolean arrayHas65and77(int[] ints) {
        for (int i = 0; i < ints.length; i++) {
            if (ints[i] == 65 | ints[i] == 77) {
                for (int j = i+1; j < ints.length; j++) {
                    if (ints[j] == 77 | ints[j] == 65) {
                        return true;
                    }
                }
            }
        }
        return false;
    }


    public boolean theTotalOfTensIs30(Integer[] ints) {
        int counter = (int) countDupes(ints);
        int [] newArray = new int[counter];
        int index = 0;
        for (int i = 0; i < ints.length; i++) {
            if (ints[i] == 10) {
                newArray[index] = ints[i];
                index++;
            }
            if (sumOfIntArray(newArray) == 30) {
                return true;
            }
         }
        return false;
    }

    public int findSecondSmallValueFromArray(int [] ints) {
        int secondSmallest = 1;
        int smallest = findMaxMinOfArray(ints).getMin();
        for (int i = 0; i < ints.length; i++) {
            if (ints[i] > smallest && smallest != secondSmallest) {
                secondSmallest = ints[i];
             }
        }
        return secondSmallest;
    }


    public int[] makeMeACopyPlease(int[] ints) {
        int [] newArray = copyArrayByLoop(ints);
        return reverseArray(newArray);
    }
}








